SystemOrganization addCategory: #ConfigurationOfRFB!

Object subclass: #ConfigurationOfRFB
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfRFB'!

!ConfigurationOfRFB class methodsFor: 'private' stamp: 'MiguelCoba 1/21/2010 01:28'!
bootstrapPackage: aString from: aPath 
	| repository version |
	repository := MCHttpRepository
				location: aPath
				user: ''
				password: ''.
	repository
		versionReaderForFileNamed: aString , '.mcz'
		do: [:reader | 
			version := reader version.
			version load.
			version workingCopy repositoryGroup addRepository: repository]! !

!ConfigurationOfRFB class methodsFor: 'private' stamp: 'MiguelCoba 1/21/2010 01:28'!
ensureMetacello
	"Bootstrap Gofer (if necessary), bootstrap ConfigurationOfMetacello (using old Gofer API), then load the latest 
	version of Metacello itself."

	Smalltalk at: #MetacelloProject ifAbsent: [
		Smalltalk at: #Gofer ifAbsent: [
			"Current version of Gofer from which to bootstrap - as of 1.0-beta.21"
			self bootstrapPackage: 'Gofer-Core-lr.115' from: 'http://seaside.gemstone.com/ss/metacello' ].
		Smalltalk at: #Gofer ifPresent: [:goferClass | | gofer |
			gofer := goferClass new
				url: 'http://seaside.gemstone.com/ss/metacello';
				yourself.
			[ gofer addPackage: 'ConfigurationOfMetacello' ] on: Warning do: [:ex | ex resume ].
			gofer load ].
		"load 'default' group of Metacello"
		(Smalltalk at: #ConfigurationOfMetacello) perform: #load ]! !

!ConfigurationOfRFB class methodsFor: 'metacello tool support' stamp: 'MiguelCoba 1/21/2010 01:28'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfRFB class methodsFor: 'metacello tool support' stamp: 'MiguelCoba 1/21/2010 01:28'!
lastMetacelloVersionLoad
	"Answer the last version loaded and the list of packages loaded for that version."

	LastVersionLoad == nil ifTrue: [ LastVersionLoad := nil -> 'default' ].
	^LastVersionLoad! !

!ConfigurationOfRFB class methodsFor: 'loading' stamp: 'MiguelCoba 1/21/2010 01:28'!
load
	"self load"

	^self project latestVersion load! !

!ConfigurationOfRFB class methodsFor: 'metacello tool support' stamp: 'MiguelCoba 1/21/2010 01:28'!
metacelloVersion: versionString loads: anArrayOrString
	"Stash the last version loaded and the list of packages loaded for that version. The list
	 of packages will be used by the tools when doing 'Load Package Version'"

	LastVersionLoad := versionString -> anArrayOrString! !

!ConfigurationOfRFB class methodsFor: 'accessing' stamp: 'MiguelCoba 1/21/2010 01:28'!
project

	^self new project! !

!ConfigurationOfRFB methodsFor: 'baselines' stamp: 'MiguelCoba 1/21/2010 01:35'!
baseline01: spec
	<version: '0.1-baseline'>
	
	spec for: #common do: [
		spec blessing: #baseline.
		spec description: 'Initial baseline for RFB'.
		spec repository: 'http://source.lukas-renggli.ch/unsorted' ].
	
	spec for: #squeakCommon do: [
		spec
			repository: 'http://source.lukas-renggli.ch/unsorted';
			package: 'RFB' ].
	
	spec for: #common do: [
		spec
			group: 'default' with: 'RFB' ].! !

!ConfigurationOfRFB methodsFor: 'baselines' stamp: 'MiguelCoba 3/20/2011 12:11'!
baseline02: spec
	<version: '0.2-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.
		spec repository: 'http://source.lukas-renggli.ch/unsorted'.
		spec package: 'RFB'.
		spec group: 'default' with: #('RFB' ). ].
! !

!ConfigurationOfRFB methodsFor: 'baselines' stamp: 'NorbertHartl 5/7/2013 10:36'!
baseline06: spec
	<version: '0.6-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.
		spec repository: 'http://smalltalkhub.com/mc/PharoExtras/RFB/main'.
		spec package: 'RFB'.
		spec group: 'default' with: #('RFB' ). ].
! !

!ConfigurationOfRFB methodsFor: 'symbolic versions' stamp: 'MiguelCoba 3/20/2011 12:27'!
development: spec
	<symbolicVersion: #'development'>

	spec for: #'common' version: #'notDefined'.
! !

!ConfigurationOfRFB methodsFor: 'accessing' stamp: 'MiguelCoba 1/21/2010 01:28'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		self class ensureMetacello.
		"Construct Metacello project"
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self.
		project := constructor project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfRFB methodsFor: 'symbolic versions' stamp: 'NorbertHartl 5/7/2013 10:36'!
stable: spec
	<symbolicVersion: #'stable'>

	spec for: #'pharo1.1.x' version: '0.3'.
	spec for: #'pharo1.2.x' version: '0.4'.
	spec for: #'pharo1.4.x' version: '0.5'.
	spec for: #'pharo2.0.x' version: '0.6'.! !

!ConfigurationOfRFB methodsFor: 'versions' stamp: 'MiguelCoba 1/21/2010 01:36'!
version01: spec
	<version: '0.1' imports: #('0.1-baseline')>
	
	spec for: #common do: [
		spec blessing: #stable.
		spec description: 'Release 0.1'.
		spec author: 'MiguelCoba'.
		spec timestamp: '01/21/2010 01:36' ].
	
	spec for: #squeakCommon do: [
		spec
		  	package: 'RFB' with: 'RFB-DamienCassou.28' ].! !

!ConfigurationOfRFB methodsFor: 'versions' stamp: 'MiguelCoba 1/21/2010 02:36'!
version02: spec
	<version: '0.2' imports: #('0.1-baseline')>
	
	spec for: #common do: [
		spec blessing: #release.
		spec description: 'Release 0.2'.
		spec author: 'MiguelCoba'.
		spec timestamp: '01/21/2010 02:36' ].
	
	spec for: #squeakCommon do: [
		spec
		  	package: 'RFB' with: 'RFB-DamienCassou.28' ].! !

!ConfigurationOfRFB methodsFor: 'versions' stamp: 'MiguelCoba 3/20/2011 12:49'!
version03: spec
	<version: '0.3' imports: #('0.2-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'release'.
		spec description: 'development version'.
		spec author: 'MiguelCoba'.
		spec timestamp: '3/20/2011 12:10'.
		spec package: 'RFB' with: 'RFB-lr.34'. ].
! !

!ConfigurationOfRFB methodsFor: 'versions' stamp: 'MiguelCoba 3/20/2011 12:44'!
version04: spec
	<version: '0.4' imports: #('0.2-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'release'.
		spec description: 'development version'.
		spec author: 'MiguelCoba'.
		spec timestamp: '3/20/2011 12:43'.
		spec package: 'RFB' with: 'RFB-MiguelCoba.36'. ].
! !

!ConfigurationOfRFB methodsFor: 'versions' stamp: 'StanislavPaskalev 10/3/2011 20:10'!
version05: spec
	<version: '0.5' imports: #('0.2-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'release'.
		spec description: 'development version'.
		spec author: 'lr'.
		spec timestamp: '3/20/2011 12:43'.
		spec package: 'RFB' with: 'RFB-lr.38'. ].
! !

!ConfigurationOfRFB methodsFor: 'versions' stamp: 'MarianoMartinezPeck 5/7/2013 09:49'!
version06: spec
	<version: '0.6' imports: #('0.6-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'release'.
		spec description: '
			- Fixed a FileDirectory access to make it run in pharo 2.0
			- Fixed leak of semaphores as explained in: http://comments.gmane.org/gmane.comp.lang.smalltalk.pharo.devel/60796'.
		spec author: 'NorbertHartl'.
		spec timestamp: '05/07/2013 10:40'.
		spec package: 'RFB' with: 'RFB-MarianoMartinezPeck.41'. ].
! !
